#!/usr/bin/perl

#Argument are the two z-matrices and the output file name

$molecule1=$ARGV[0];
$molecule2=$ARGV[1];
$outfile=$ARGV[2];

if($molecule1 eq "thymine.zmat" || $molecule1 eq "uracil.zmat" || $molecule1 eq "cytosine.zmat") { $seed1 = "c6";}
elsif($molecule1 eq "guanine.zmat" || $molecule1 eq "adenine.zmat") {$seed1 = "c4";}
else {print "Your first zmatrix is not recognized. \n";}
print "Seed for molecule 1 is $seed1. \n";
if($molecule2 eq "thymine.zmat" || $molecule2 eq "uracil.zmat" || $molecule2 eq "cytosine.zmat") { $seed2 = "c6u";}
elsif($molecule2 eq "guanine.zmat" || $molecule2 eq "adenine.zmat") {$seed2 = "c4u";}
else {print "Your second zmatrix is not recognized. \n";}
print "Seed for molecule 2 is $seed2. \n";


#Read in initial zmat
open(TXT, "<$molecule1");
@MOL1 = <TXT>;
close(TXT);
open(TXT, "<$molecule2");
@MOL2 = <TXT>;
close(TXT);
open(OUT, ">$outfile");

$length1 = @MOL1;
$length2 = @MOL2;

print OUT "x1 \n";
print OUT "xr x1 rise \n";
print OUT "xs xr slide x1 90. \n";
print OUT "x1u xs shift xr 90. x1  90. \n";
print OUT "$seed1  x1  r1  xr  90. xs  0. \n";
print OUT "x2  x1  1.  $seed1  90. xr  90. \n";

#Print the first part of the zmat
for($i=3; $i<$length1; $i++)
{
  if ( $MOL1[$i] =~ m/^\s*$/g )
      { last; }
  
  else
  {
   chomp($MOL1[$i]);
#   print "$i \n";
   print OUT "$MOL1[$i] \n";
   next;
  }
}

$blank1 = $i;
#print "$blank1 \n";

print OUT "xuz x1u 1.0 xs 90. xr 90. \n";
print OUT "xux x1u 1.0 xs 90. xr 180. \n";
print OUT "$seed2  x1u  ru1   xuz  tilt  xux  twist \n";
print OUT "x2u  x1u  1.   $seed2  90.   xuz  roll \n";

#Start with 3 because first three lines handled by above
for($j=3; $j<$length2; $j++)
{
  if ($MOL2[$j] =~ m/^\s*$/g )
         { last; }

  else
  { 
  @components = split(/\s+/,$MOL2[$j]);
  $components[0] = ($components[0] . u);
  $components[1] = ($components[1] . u);
  $components[2] =~ m/([a-z])(\d+)/ ;
  $components[2] = ($1 . u . $2);
  $components[3] = ($components[3] . u);
  $components[4] =~ m/([a-z]*)(\d+\.*)/ ;
  if ($1 eq "") { $components[4] = $2; }
  else { $components[4] = ($1 . u . $2); }
  $components[5] = ($components[5] . u);
  $components[6] =~ m/([a-z]*)(\d+\.*)/ ;
  if ($1 eq "") { $components[6] = $2; }
  else { $components[6] = ($1 . u . $2); }
  print OUT "@components \n";
  next;
  } 
}

$blank2 = $j;

%lookup = ();
#Now print all the variable values under the zmat
print OUT "\n";
for ($i = $blank1 + 1; $i<$length1; $i++)
{
 $MOL1[$i] =~ m/\s*([a-z]\d+)(\s*\-*\d+\.\d*)/ ;
 print OUT "$1 $2 \n";
 $lookup{$1} = $2;
}

for ($j = $blank2 + 1; $j<$length2; $j++)
{
 $MOL2[$j] =~ m/\s*([a-z])(\d+)(\s*\-*\d+\.\d*)/ ;
 $cat = ( $1 . u . $2 );
 print OUT "$cat $3 \n";
 $lookup{$cat} = $3;
}

print OUT "\n";
print OUT "rise \n";
print OUT "slide \n";
print OUT "shift \n";
print OUT "d1 \n";
print OUT "tilt \n";
print OUT "twist \n";
print OUT "roll \n";
